/*******************************************************************************
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ******************************************************************************/
package javax.tools.diagnostics.vm.spi.delegates;

import java.io.File;
import java.io.IOException;

import javax.tools.diagnostics.vm.DumpDescriptor;
import javax.tools.diagnostics.vm.DumpHandle;
import javax.tools.diagnostics.vm.DumpInitiatorDelegate;
import javax.tools.diagnostics.vm.spi.DumpInitiatorCapabilities;

public class JavaDumpDelegate implements DumpInitiatorDelegate {

	/*
	 * (non-Javadoc)
	 * 
	 * @see javax.tools.diagnostics.vm.DumpInitiatorDelegate#dump()
	 */

	private boolean createDump(DumpDescriptor copy) throws IOException {

		File dumpFile=new File("dump.kato");
		XMLDumpWriter writer=new XMLDumpWriter();
		writer.write(dumpFile);
		return true;
	
		
	}

	public boolean available() {
		return true;
	}

	@Override
	public DumpHandle createDumpHandle() {
		return new DumpHandle() {
			
			@Override
			public boolean dump() throws IOException {
				return createDump(new DumpDescriptor());
			}
		};
	}

	@Override
	public DumpHandle createDumpHandle(DumpDescriptor descriptor) {
		final DumpDescriptor copy=(DumpDescriptor) descriptor.copy();
		
		return new DumpHandle() {
			
			@Override
			public boolean dump() throws IOException {
				return createDump(copy);
			}
		};
	}

	@Override
	public DumpInitiatorCapabilities getCapabilities() {
		return new DumpInitiatorCapabilities() {
		};
	}

	@Override
	public String getDumpType() {
		return "dump.kato";
	}
}