/*******************************************************************************
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ******************************************************************************/
package javax.tools.diagnostics.image;

/**
 * This class is the superclass of all exceptions thrown by javax.tools.diagnostics classes
 *
 */
public class DiagnosticException extends Exception {
	private static final long serialVersionUID = -8031802750405644473L;

	/**
	 * Build exception with the given description
	 * @param description
	 */
	public DiagnosticException(String description) {
        super(description);
    }
    
    /**
     * Build exception with no description
     */
    public DiagnosticException() {
        super();
    }
}
