/*******************************************************************************
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ******************************************************************************/
package org.apache.kato.common;

/**
 * The basic types of the HProf format.
 * Identifies the types of fields within classes, object instances
 * and primitive types.
 */
public interface BasicType {
	public static final int OBJECT = 2;
	public static final int BOOLEAN = 4;
	public static final int CHAR = 5;
	public static final int FLOAT = 6;
	public static final int DOUBLE = 7;
	public static final int BYTE = 8;
	public static final int SHORT = 9;
	public static final int INT = 10;
	public static final int LONG = 11;
}