/*******************************************************************************
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ******************************************************************************/
package org.apache.kato.common;

import java.io.IOException;



public class DataReader {

	
	public static int read4Bytes(byte[] data) {
		
		return read4Bytes(data,0);
	}

	public static int read4Bytes(byte[] data, int i) {
		
		byte b1=data[i+0];
		byte b2=data[i+1];
		byte b3=data[i+2];
		byte b4=data[i+3];
		return  (b1 << 24 ) + (b2 << 16) + (b3 << 8) + b4;
		
		 

	}

	public static short read2Bytes(byte[] data, int i) {
		byte b1=data[i+0];
		byte b2=data[i+1];
		return   (short) ((b1 << 8) + b2);
		
	}

	public static long readNumber(byte[] data, int offset, int length) {
	
		long value=0;
		for(int i=0;i<length;i++) {
			value = value << 8;
			byte b=data[offset+i];
			value = value + (b & 0xff);
		}
		return value;
	}
	
	public static long readNumber(IDataProvider provider, int length) throws IOException {
		
		long value=0;
		for(int i=0;i<length;i++) {
			value = value << 8;
			short b=provider.readByte();
			value = value + (b &0xff);
		}
		return value;
	}

	public static byte[] readByteArray(byte[] data, int offset, int length) {
		byte[] results=new byte[length];
		System.arraycopy(data,offset,results,0,length);
		return results;
	}
}
