/*******************************************************************************
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ******************************************************************************/
package org.apache.kato.hprof.image;

import java.util.LinkedList;
import java.util.List;

import javax.tools.diagnostics.image.ImageAddressSpace;
import javax.tools.diagnostics.image.ImagePointer;
import javax.tools.diagnostics.image.ImageProcess;


final public class ImageAddressSpaceImpl implements ImageAddressSpace {
	
	/**
	 * 
	 */
	private final ImageImpl imageImpl;
	private ImageProcess currentProcess=null;
	
	/**
	 * @param imageImpl
	 */
	ImageAddressSpaceImpl(ImageImpl imageImpl) {
		this.imageImpl = imageImpl;
		currentProcess=new ImageProcessImpl(this.imageImpl);
	}

	
	
	@Override
	public ImageProcess getCurrentProcess() {
		
			return currentProcess;
	}

	@Override
	public List getImageSections() {
		
		List l=new LinkedList();
		return l;
	}

	@Override
	public ImagePointer getPointer(long address) {		
		return new ImagePointerImpl(address, this);
	}

	@Override
	public List getProcesses() {
		List l=new LinkedList();
		l.add(currentProcess);
		return l;
	}
}