/*******************************************************************************
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ******************************************************************************/
package org.apache.kato.hprof.image;

import java.io.File;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import javax.tools.diagnostics.image.CorruptDataException;
import javax.tools.diagnostics.image.DataUnavailable;
import javax.tools.diagnostics.image.Image;

import org.apache.kato.hprof.datalayer.HProfFile;

public class ImageImpl implements Image {

	HProfFile file=null;
	List addressSpaces = new LinkedList();
	
	public ImageImpl(HProfFile file) {
		if(file==null) throw new IllegalArgumentException("file is null");
		this.file=file;
		addressSpaces.add(new ImageAddressSpaceImpl(this));
	}
	@Override
	public List getAddressSpaces() {		
		return addressSpaces;
	}

	@Override
	public long getCreationTime() throws DataUnavailable {
		
		return file.getTimeStamp();
	
	}

	@Override
	public String getHostName() throws DataUnavailable, CorruptDataException {
		
		throw new DataUnavailable();
		
	}

	@Override
	public Iterator getIPAddresses() throws DataUnavailable {
		
		throw new DataUnavailable();
	}

	@Override
	public long getInstalledMemory() throws DataUnavailable {
		throw new DataUnavailable();
	}

	@Override
	public int getProcessorCount() throws DataUnavailable {
		throw new DataUnavailable();
	}

	@Override
	public String getProcessorSubType() throws DataUnavailable,
			CorruptDataException {
		throw new DataUnavailable();
	}

	@Override
	public String getProcessorType() throws DataUnavailable,
			CorruptDataException {
		throw new DataUnavailable();
	}

	@Override
	public String getSystemSubType() throws DataUnavailable,
			CorruptDataException {
		throw new DataUnavailable();
	}

	@Override
	public String getSystemType() throws DataUnavailable, CorruptDataException {
		throw new DataUnavailable();
	}
	@Override
	public File getSource() {
		return file.getSource();
	}

}
