/*******************************************************************************
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ******************************************************************************/
package org.apache.kato.hprof.java;

import org.apache.kato.hprof.datalayer.IGCInstanceHeapDumpRecord;

/**
 * Implements a IGCInstanceHeapDumpRecord, to be wrapped by a JavaObjectInstanceImpl.
 * 
 * uses setters to set values.
 * 
 * These have to make sense in context with the classes.
 *
 */
public class GCInstanceHeapDumpRecordTest implements IGCInstanceHeapDumpRecord{
	long[] slots;
	
	public void setSlots(long[] slots) {
		this.slots = slots;
	}
	 
	long id;
	public void setID(long id) {
		this.id = id;
	}
	@Override
	public long getID() {
		return id;
	}
	long classObjectID;
	public void setClassObjectID(long id) {
		this.classObjectID = id;
	}
	@Override
	public long getClassObjectID() {
		return classObjectID;
	}
	

	int stackTraceNumber;
	public void setStackTraceNumber(int num) {
		this.stackTraceNumber = num;
	}
	@Override
	public int getStackTraceNumber() {
		return stackTraceNumber;
	}
	
	@Override
	public boolean getBooleanField(int offset) {
		return !(slots[offset] == 0L);
	}

	@Override
	public byte getByteField(int offset) {
		return (byte) slots[offset];
	}

	@Override
	public char getCharField(int offset) {
		return (char) slots[offset];
	}

	@Override
	public double getDoubleField(int offset) {
		return Double.longBitsToDouble(slots[offset]);
	}

	@Override
	public float getFloatField(int offset) {
		return Float.intBitsToFloat((int) slots[offset]);
	}

	@Override
	public long getIDField(int offset) {
		return slots[offset];
	}

	@Override
	public int getIntegerField(int offset) {
		return (int) slots[offset];
	}

	@Override
	public long getLongField(int offset) {
		return slots[offset];
	}

	@Override
	public short getShortField(int offset) {
		return (short) slots[offset];
	}


	
}