/*******************************************************************************
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ******************************************************************************/
package org.apache.kato.hprof.java;

import org.apache.kato.hprof.IJavaClass;
import org.apache.kato.hprof.datalayer.ConstantPoolEntry;
import org.apache.kato.hprof.datalayer.InstanceFieldEntry;
import org.apache.kato.hprof.datalayer.StaticFieldEntry;

/**
 * Implements a IJavaClass for consumption by
 * JavaClassImpl.
 *
 * Uses setters to set all values.
 */
public class JavaTestClass implements IJavaClass {
	long loaderID;
	public void  setClassLoadersObjectID(long id) {
		this.loaderID = id;
	}
	@Override
	public long getClassLoaderObjectID() {
		return loaderID;
	}

	String className;
	public void setClassName(String className) {
		this.className = className;
	}
	@Override
	public String getClassName() {
		return className;
	}

	long classObjectID;
	public void setClassObjectID(long id) {
		this.classObjectID = id;
	}
	@Override
	public long getClassObjectID() {
		return classObjectID;
	}

	int serialNo;
	public void setClassSerialNumber(int serialNo) {
		this.serialNo = serialNo;
	}
	@Override
	public int getClassSerialNumber() {
		return serialNo;
	}

	ConstantPoolEntry[] constantPoolEntries;
	public void setConstantPoolEntries(ConstantPoolEntry[] entries) {
		this.constantPoolEntries = entries;
	}

	@Override
	public ConstantPoolEntry[] getConstantPoolEntries() {
		return constantPoolEntries;
	}

	InstanceFieldEntry[] instanceFieldEntries;
	public void setInstanceFields(InstanceFieldEntry[] entries) {
		this.instanceFieldEntries = entries;
	}
	@Override
	public InstanceFieldEntry[] getInstanceFields() {
		return instanceFieldEntries;
	}

	
	int instanceSize;
	public void setInstanceSize(int size) {
		this.instanceSize = size;
	}
	@Override
	public int getInstanceSize() {
		return instanceSize;
	}

	int offsetSize;
	public void setOffsetSize(int size) {
		this.offsetSize = size;
	}
	@Override
	public int getOffsetSize() {
		return offsetSize;
	}

	long protectionDomainObjectID;
	public void setProtectionDomainObjectID(long id) {
		this.protectionDomainObjectID = id;
	}
	@Override
	public long getProtectionDomainObjectID() {
		return protectionDomainObjectID;
	}

	long signersObjectID;
	public void setSignersObjectID(long id) {
		this.signersObjectID = id;
	}
	@Override
	public long getSignersObjectID() {
		return signersObjectID;
	}

	int stackTraceSerialNumber;
	public void setStackTraceSerialNumber(int num) {
		this.stackTraceSerialNumber = num;
	}
	@Override
	public int getStackTraceSerialNumber() {
		return stackTraceSerialNumber;
	}

	StaticFieldEntry staticFieldEntries[];
	public void setStaticFields(StaticFieldEntry[] entries) {
		this.staticFieldEntries = entries;
	}
	@Override
	public StaticFieldEntry[] getStaticFields() {
		return staticFieldEntries;
	}

	long superClassObjectID;
	public void setSuperClassObjectID(long id) {
		this.superClassObjectID = id;
	}
	@Override
	public long getSuperClassObjectID() {
		return superClassObjectID;
	}

}
