/*******************************************************************************
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ******************************************************************************/
package org.apache.kato.hprof.java;

import org.apache.kato.common.BasicType;
import org.apache.kato.hprof.datalayer.IGCPrimitiveArrayHeapDumpRecord;

/**
 * 
 * @author monteith
 *
 */
public class PrimitiveArrayTestImpl implements IGCPrimitiveArrayHeapDumpRecord, BasicType{

	long ID;
	public void setID(long id) {
		this.ID = id;
	}
	@Override
	public long getID() {
		return this.ID;
	}

	int stackTraceNumber;
	public void setStackTraceNumber(int num) {
		this.stackTraceNumber = num;
	}
	@Override
	public int getStackTraceNumber() {
		return stackTraceNumber;
	}
	
	@Override
	public short getElementType() {
		return elementType;
	}
	
	@Override
	public int getNumberOfElements() {
		return numElements;
	}
	
	
	boolean[] booleanArray;
	byte[] byteArray;
	char[] charArray;
	short[] shortArray;
	int[] intArray;
	long[] longArray;
	float[] floatArray;
	double[] doubleArray;
	short elementType;
	int numElements;
	
	public PrimitiveArrayTestImpl(boolean[] array) {
		this.booleanArray = array;
		this.numElements = array.length;
		this.elementType = BOOLEAN;
	}
	
	@Override
	public boolean getBooleanElement(int index) {
		return booleanArray[index];
	}

	public PrimitiveArrayTestImpl(byte[] array) {
		this.byteArray = array;
		this.numElements = array.length;
		this.elementType = BYTE;
	}
	
	@Override
	public short getByteElement(int index) {
		return byteArray[index];
	}

	public PrimitiveArrayTestImpl(char[] array) {
		this.charArray = array;
		this.numElements = array.length;
		this.elementType = CHAR;
	}
	
	@Override
	public char getCharElement(int index) {
		return charArray[index];
	}

	public PrimitiveArrayTestImpl(double[] array) {
		this.doubleArray = array;
		this.numElements = array.length;
		this.elementType = DOUBLE;
	}
	
	@Override
	public double getDoubleElement(int index) {
		return doubleArray[index];
	}



	public PrimitiveArrayTestImpl(float[] array) {
		this.floatArray = array;
		this.numElements = array.length;
		this.elementType = FLOAT;
	}
	
	@Override
	public float getFloatElement(int index) {
		return floatArray[index];
	}
	public PrimitiveArrayTestImpl(int[] array) {
		this.intArray = array;
		this.numElements = array.length;
		this.elementType = INT;
	}
	@Override
	public int getIntElement(int index) {
		return intArray[index];
	}
	
	public PrimitiveArrayTestImpl(long[] array) {
		this.longArray = array;
		this.numElements = array.length;
		this.elementType = LONG;
	}
	
	@Override
	public long getLongElement(int index) {
		return longArray[index];
	}



	public PrimitiveArrayTestImpl(short[] array) {
		this.shortArray = array;
		this.numElements = array.length;
		this.elementType = SHORT;
	}
	
	@Override
	public short getShortElement(int index) {
		return shortArray[index];
	}


}
