/*******************************************************************************
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ******************************************************************************/
package test.apache.kato.hprof;

import test.apache.kato.hprof.image.TestImage;
import test.apache.kato.hprof.image.TestImageAddressSpace;
import test.apache.kato.hprof.image.TestImageFactory;
import test.apache.kato.hprof.image.TestImageProcess;
import test.apache.kato.hprof.java.TestJavaRuntime;
import junit.framework.Test;
import junit.framework.TestSuite;

public class AllTests {

	public static Test suite() {
		TestSuite suite = new TestSuite("Test for test.apache.kato.hprof");
		//$JUnit-BEGIN$
		suite.addTestSuite(TestImageProcess.class);
		suite.addTestSuite(TestImageFactory.class);
		suite.addTestSuite(TestImageAddressSpace.class);
		suite.addTestSuite(TestImage.class);
		
		suite.addTestSuite(TestJavaRuntime.class);
		
		//$JUnit-END$
		return suite;
	}

}
