/*******************************************************************************
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ******************************************************************************/
package org.apache.kato.tools.jdi;
import java.io.IOException;
import java.io.OutputStream;


public class JDIOutputStream extends OutputStream {
	private OutputStream outStream;
	
	public JDIOutputStream(OutputStream outStream){
		this.outStream = outStream;
	}
	
	@Override
	public synchronized void write(int arg0) throws IOException {
		outStream.write(arg0);
			
	}
	
	@Override
	public void flush() throws IOException{
		outStream.flush();
	}
	
	@Override
	public void write(byte [] b) throws IOException{
		outStream.write(b);
		
	}
	
	@Override
	public void write(byte [] b, int off, int len) throws IOException{
		outStream.write(b, off, len);
	}
	
	@Override
	public void close() throws IOException{
		outStream.close();
	}
	
	public OutputStream getStream(){
		return outStream;
	}
	
	public void setStream(OutputStream outStream){
		this.outStream = outStream;
	}
	
	
	

}
