/*******************************************************************************
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ******************************************************************************/


#include "org_apache_kato_common142_DumpTrigger.h"

#ifdef __linux__
#include <signal.h>
#elif WIN32
#include <Windows.h>
#endif
/*
 * Class:     org_apache_kato_common_DumpTrigger
 * Method:    getNativeProcessID
 * Signature: ()I
 */
JNIEXPORT jint JNICALL Java_org_apache_kato_common142_DumpTrigger_getNativeProcessID
(JNIEnv *env, jobject obj) {
	 jint result=0;

#ifdef __linux__
	int pid=getpid();
	result=pid;
#elif WIN32
	 DWORD ProcessId = GetCurrentProcessId();
	 result=ProcessId;
#endif

	 return result;

}

/*
 * Class:     org_apache_kato_common_DumpTrigger
 * Method:    triggernativeDump
 * Signature: ()Z
 */JNIEXPORT jboolean JNICALL Java_org_apache_kato_common142_DumpTrigger_sendDumpSignal
 (JNIEnv *env, jobject obj, jint processID) {

	
	jboolean result=JNI_FALSE;
#ifdef __linux__

	pid_t pid=processID;
	kill(pid,SIGQUIT);
	result=JNI_TRUE;
#elif WIN32	

	GenerateConsoleCtrlEvent(CTRL_BREAK_EVENT,0);
	result=JNI_TRUE;
#endif

	return result;
	
}



