/*******************************************************************************
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ******************************************************************************/
package org.apache.kato.tck.api;

import java.util.Properties;

public class DumpDefinition {

	private Properties props=new Properties();
	
	public DumpDefinition () {
		
	}

	public String getJvmBuildDate() {
		return props.getProperty("jvm.build.date");
	}

	/**
	 * Build date of JVM
	 * 
	 * @param jvmBuildDate in form of yyyy/mm/dd
	 */
	public void setJvmBuildVersion(String jvmBuildVersion) {
		props.setProperty("jvm.build.version",jvmBuildVersion);
	}
	
	public String toString() {
		return props.toString();
	}
	
	public Properties getProperties() {
		
	
		return props;
	}
}
