/*******************************************************************************
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ******************************************************************************/
package org.apache.kato.tck.harness;

import javax.tools.diagnostics.image.Image;

import org.apache.kato.tck.api.IImageCreator;


public abstract class TCKProcessTestcase extends AbstractTCKTestcase{

	private static Image image=null;
	
	private static IImageCreator imageCreator=null;
	
	protected Image getImage()
	{
		if(image==null) {	
			IImageCreator creator=getImageCreator();
			
			try {
				image=creator.createProcessImage();
			} catch (Exception e) {
				
				report(e,"unable to create process image from dump");
			}
			if(image==null) report("unable to create process image from dump");
		}
		return image;
	}
	
	private IImageCreator getImageCreator() 
	{
		
	
		if(imageCreator!=null) return imageCreator;

		String className="fixme";
	
		Class clazz=null;
		try {
			clazz = Class.forName(className);
		} catch (ClassNotFoundException e) {
			report(e,"cannot locate Image generator class "+className);

		}
		try {
			imageCreator=(IImageCreator) clazz.newInstance();
		} catch (Exception e) {
			report(e,"unable to instantiate Image creator class "+className);
		}
		return imageCreator;
	}

}
