/*******************************************************************************
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ******************************************************************************/
package org.apache.kato.tck.harness;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintStream;
import java.io.PrintWriter;

public class TCKReporter {

	private PrintWriter out=null;
	
	public TCKReporter(PrintWriter out) {
		this.out=out;
	}
	public TCKReporter(PrintStream out) {
		this.out=new PrintWriter(out);
	}
	public TCKReporter() {
		this(System.out);
	}
	public TCKReporter(File output) throws IOException {
		FileWriter fw=new FileWriter(output);
		this.out=new PrintWriter(fw);
	}
	public void report(String message) {
		out.println(message);
		out.flush();
	}
	public void report(String text, Throwable e) {
		out.println(text);
		out.flush();
		e.printStackTrace(out);
		
	}

}
