/*******************************************************************************
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ******************************************************************************/

package org.apache.kato.tck.harness;

import java.io.PrintStream;
import java.io.PrintWriter;

/**
 * 
 */
public class VisitStatisticsReporter {

	private PrintStream out=null;
	
	public VisitStatisticsReporter() {
		this(System.out);
	}
	/**
	 * @param out2
	 */
	public VisitStatisticsReporter(PrintStream out) {
		this.out=out;
		}
	public static void report(VisitStatistics stats) {
		VisitStatisticsReporter reporter=new VisitStatisticsReporter();
		reporter.reportStatistics(stats);
	}

	/**
	 * @param stats
	 */
	public void reportStatistics(VisitStatistics stats) {
		
		out.println("Roots  :"+stats.roots);
		out.println("Containers:"+stats.containers);
		out.println("Ignored Containers:"+stats.ignoredContainers);
		out.println("Matched Files:"+stats.matchedFiles);
		out.println("unmatched Files:"+stats.unmatchedFiles);
	}
}
