/*******************************************************************************
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ******************************************************************************/

package org.apache.kato.tck.harness.scenario;

import java.io.File;
import java.io.IOException;

public class PlaceboDumpTrigger implements IDumpTrigger {

	public void dump() {
		String target=System.getProperty("kato.dump.placebo.location");
		File dump=null;
		if(target==null) {
			dump=new File("kato.dump.placebo");
		}
		else {
			File root=new File(target);
			dump=new File(root,"kato.dump.placebo");
		}
		System.out.println("Placebo Dump Triggered to "+dump.getAbsolutePath());
		
		try {
			dump.createNewFile();
		} catch (IOException e) {
			throw new RuntimeException(e);
			
		}
		
	}

	/**
	 * Sets the dump format to produce.
	 * Ignored by this trigger
	 * 
	 */
	public void setDumpFormat(String dumpFormat) {
		
		
	}

}
