/*******************************************************************************
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ******************************************************************************/
package org.apache.kato.tck.scenario142.javaruntime;

import org.apache.kato.tck.harness.scenario.ScenarioElement;




/**
 * 
 * 
 */
public class SetupJavaRuntimeThreads extends ScenarioElement  {

	public static final String DTFJ_TCK_T3 = "dtfj_tck_t3";
	public static final String DTFJ_TCK_T2 = "dtfj_tck_t2";
	public static final String DTFJ_TCK_T1 = "dtfj_tck_t1";

	public void configureSetThreads() 
	{
		
		
		ThreadGroup group=new ThreadGroup("dtfj_tck");
		
		
		Thread t1=new Thread(group,new PausingRunnable(),DTFJ_TCK_T1);
		t1.start();
		
		Thread t2=new Thread(group,new PausingRunnable(),DTFJ_TCK_T2);
		t2.start();
		
		Thread t3=new Thread(group,new PausingRunnable(),DTFJ_TCK_T3);
		t3.start();
		
	}

	class PausingRunnable implements Runnable {
		public void run() {
			try {
				Thread.sleep(1000000);
			} catch (InterruptedException e) {
				
				e.printStackTrace();
			}
			
		}
	}
}

