/*******************************************************************************
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ******************************************************************************/
package org.apache.kato.tck.scenario142.javaruntime;

import java.util.List;

import javax.tools.diagnostics.runtime.java.JavaClass;
import javax.tools.diagnostics.runtime.java.JavaClassLoader;

import org.apache.kato.tck.harness.TCKJavaRuntimeTestcase;

/**
 *	Tests that an uninitialized class can be found.
 *
 */
public class TestJavaClass_uninitialized extends TCKJavaRuntimeTestcase {
	public void testFindClass() throws Exception {
		List<JavaClassLoader> loaders = getJavaRuntime().getJavaClassLoaders();
		
		String className = this.getClass().getPackage().getName().replace('.', '/').concat("/BlockedClass");
		JavaClass clazz = null;
		for (JavaClassLoader loader : loaders) {
			clazz = loader.findClass(className);
			if (clazz != null) {
				break;
			}
		}
		
		assertNotNull("Could not find "+className,clazz);
	}
}
