/*******************************************************************************
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ******************************************************************************/
package org.apache.kato.tck.scenario142.javaruntime;

import javax.tools.diagnostics.runtime.java.JavaField;
import javax.tools.diagnostics.runtime.java.JavaObject;

import org.apache.kato.tck.harness.TCKJavaRuntimeTestcase;
import org.apache.kato.tck.scenario142.javaruntime.SetupJavaField_get;


public class TestJavaField_get extends TCKJavaRuntimeTestcase {
		
	
	static JavaObject thisObject = null;	
	static SetupJavaField_get setup=new SetupJavaField_get();
	
	public JavaObject getScenerioReference() {
		if (thisObject == null) {
			thisObject = super.getScenerioReference();
		}	
		return thisObject;		
	}

	static String wrongClassName = SetupJavaField_get.WrongClass.class.getName().replace('.', '/');
	
	static JavaObject wrongClassObject = null;
	public void setUp() {
		if (wrongClassObject == null) {
			wrongClassObject = getJavaObjectByClassname(wrongClassName);
		}
	}
	
	public void testByteValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField byteField = getJavaField(thisJavaObject, "byteValue");
		
		Byte byteObj = (Byte) byteField.get(thisJavaObject);
		
		assertEquals(byteObj.byteValue(), setup.byteValue);		
	}
	
	public void testMaxByteValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField byteField = getJavaField(thisJavaObject, "maxByteValue");
		
		Byte byteObj = (Byte) byteField.get(thisJavaObject);
		
		assertEquals(byteObj.byteValue(), setup.maxByteValue);		
	}
	
	public void testMinByteValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField byteField = getJavaField(thisJavaObject, "minByteValue");
		
		Byte byteObj = (Byte) byteField.get(thisJavaObject);
		
		assertEquals(byteObj.byteValue(), setup.minByteValue);		
	}
	
	public void testShortValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField shortField = getJavaField(thisJavaObject, "shortValue");
		
		Short shortObj = (Short) shortField.get(thisJavaObject);
		
		assertEquals(shortObj.shortValue(), setup.shortValue);		
	}
	
	public void testMaxShortValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField shortField = getJavaField(thisJavaObject, "maxShortValue");
		
		Short shortObj = (Short) shortField.get(thisJavaObject);
		
		assertEquals(shortObj.shortValue(), setup.maxShortValue);		
	}
	
	public void testMinShortValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField shortField = getJavaField(thisJavaObject, "minShortValue");
		
		Short shortObj = (Short) shortField.get(thisJavaObject);
		
		assertEquals(shortObj.shortValue(), setup.minShortValue);		
	}
	
	public void testCharValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField charField = getJavaField(thisJavaObject, "charValue");
		
		Character charObj = (Character) charField.get(thisJavaObject);
		
		assertEquals(charObj.charValue(), setup.charValue);		
	}
	
	public void testMaxCharValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField charField = getJavaField(thisJavaObject, "maxCharValue");
		
		Character charObj = (Character) charField.get(thisJavaObject);
		
		assertEquals(charObj.charValue(), setup.maxCharValue);		
	}
	
	public void testMinCharValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField charField = getJavaField(thisJavaObject, "minCharValue");
		
		Character charObj = (Character) charField.get(thisJavaObject);
		
		assertEquals(charObj.charValue(), setup.minCharValue);		
	}
	
	public void testIntValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField intField = getJavaField(thisJavaObject, "intValue");
		
		Integer intObj = (Integer) intField.get(thisJavaObject);
		
		assertEquals(intObj.intValue(), setup.intValue);		
	}
	
	public void testMaxIntValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField intField = getJavaField(thisJavaObject, "maxIntValue");
		
		Integer intObj = (Integer) intField.get(thisJavaObject);
		
		assertEquals(intObj.intValue(), setup.maxIntValue);		
	}
	
	public void testMinIntValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField intField = getJavaField(thisJavaObject, "minIntValue");
		
		Integer intObj = (Integer) intField.get(thisJavaObject);
		
		assertEquals(intObj.intValue(), setup.minIntValue);		
	}
	
	public void testFloatValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField floatField = getJavaField(thisJavaObject, "floatValue");
		
		Float floatObj = (Float) floatField.get(thisJavaObject);
		
		assertEquals(floatObj.floatValue(), setup.floatValue, 0.0);		
	}
	
	public void testMaxFloatValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField floatField = getJavaField(thisJavaObject, "maxFloatValue");
		
		Float floatObj = (Float) floatField.get(thisJavaObject);
		
		assertEquals(floatObj.floatValue(), setup.maxFloatValue, 0.0);		
	}
	
	public void testMinFloatValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField floatField = getJavaField(thisJavaObject, "minFloatValue");
		
		Float floatObj = (Float) floatField.get(thisJavaObject);
		
		assertEquals(floatObj.floatValue(), setup.minFloatValue, 0.0);		
	}
	
	public void testDoubleValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField doubleField = getJavaField(thisJavaObject, "doubleValue");
		
		Double doubleObj = (Double) doubleField.get(thisJavaObject);
		
		assertEquals(doubleObj.doubleValue(), setup.doubleValue, 0.0);		
	}
	
	public void testMaxDoubleValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField doubleField = getJavaField(thisJavaObject, "maxDoubleValue");
		
		Double doubleObj = (Double) doubleField.get(thisJavaObject);
		
		assertEquals(doubleObj.doubleValue(), setup.maxDoubleValue, 0.0);		
	}
	
	public void testMinDoubleValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField doubleField = getJavaField(thisJavaObject, "minDoubleValue");
		
		Double doubleObj = (Double) doubleField.get(thisJavaObject);
		
		assertEquals(doubleObj.doubleValue(), setup.minDoubleValue, 0.0);		
	}
	
	public void testStringValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField stringField = getJavaField(thisJavaObject, "stringValue");
		
		JavaObject stringObject = (JavaObject) stringField.get(thisJavaObject);
		
		assertEquals(String.class.getName().replace('.','/'), stringObject.getJavaClass().getName());		
	}
	
	public void testObjectValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField objectField = getJavaField(thisJavaObject, "objectValue");
		
		JavaObject objectObject = (JavaObject) objectField.get(thisJavaObject);
		
		assertEquals(Object.class.getName().replace('.','/'), objectObject.getJavaClass().getName());		
	}
	
	public void testNullValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField objectField = getJavaField(thisJavaObject, "nullValue");
		
		JavaObject objectObject = (JavaObject) objectField.get(thisJavaObject);
		
		assertNull(objectObject);		
	}
	
	public void testNullObjectInstance() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField objectField = getJavaField(thisJavaObject, "objectValue");
		
		try{
			JavaObject objectObject = (JavaObject) objectField.get(null);
			fail("Didn't get expected NullPointerException");
		}catch(NullPointerException e) {
			// expected - should get NPE with no object when passed to instance JavaField
		}
		
	}
	
	public void testByteStaticValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField byteField = getJavaField(thisJavaObject, "byteStaticValue");
		
		Byte byteObj = (Byte) byteField.get(null);
		
		assertEquals(byteObj.byteValue(), SetupJavaField_get.byteStaticValue);		
	}

	public void testMaxByteStaticValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField byteField = getJavaField(thisJavaObject, "maxByteStaticValue");
		
		Byte byteObj = (Byte) byteField.get(null);
		
		assertEquals(byteObj.byteValue(), SetupJavaField_get.maxByteStaticValue);		
	}

	public void testMinByteStaticValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField byteField = getJavaField(thisJavaObject, "minByteStaticValue");
		
		Byte byteObj = (Byte) byteField.get(null);
		
		assertEquals(byteObj.byteValue(), SetupJavaField_get.minByteStaticValue);		
	}

	
	public void testShortStaticValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField shortField = getJavaField(thisJavaObject, "shortStaticValue");
		
		Short shortObj = (Short) shortField.get(null);
		
		assertEquals(shortObj.shortValue(), SetupJavaField_get.shortStaticValue);		
	}
	
	public void testMaxShortStaticValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField shortField = getJavaField(thisJavaObject, "maxShortStaticValue");
		
		Short shortObj = (Short) shortField.get(null);
		
		assertEquals(shortObj.shortValue(), SetupJavaField_get.maxShortStaticValue);		
	}
	
	public void testMinShortStaticValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField shortField = getJavaField(thisJavaObject, "minShortStaticValue");
		
		Short shortObj = (Short) shortField.get(null);
		
		assertEquals(shortObj.shortValue(), SetupJavaField_get.minShortStaticValue);		
	}

	
	public void testCharStaticValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField charField = getJavaField(thisJavaObject, "charStaticValue");
		
		Character charObj = (Character) charField.get(null);
		
		assertEquals(charObj.charValue(), SetupJavaField_get.charStaticValue);		
	}
	
	public void testMaxCharStaticValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField charField = getJavaField(thisJavaObject, "maxCharStaticValue");
		
		Character charObj = (Character) charField.get(null);
		
		assertEquals(charObj.charValue(), SetupJavaField_get.maxCharStaticValue);		
	}
	
	public void testMinCharStaticValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField charField = getJavaField(thisJavaObject, "minCharStaticValue");
		
		Character charObj = (Character) charField.get(null);
		
		assertEquals(charObj.charValue(), SetupJavaField_get.minCharStaticValue);		
	}
	
	public void testIntStaticValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField intField = getJavaField(thisJavaObject, "intStaticValue");
		
		Integer intObj = (Integer) intField.get(null);
		
		assertEquals(intObj.intValue(), SetupJavaField_get.intStaticValue);		
	}
	
	public void testMaxIntStaticValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField intField = getJavaField(thisJavaObject, "maxIntStaticValue");
		
		Integer intObj = (Integer) intField.get(null);
		
		assertEquals(intObj.intValue(), SetupJavaField_get.maxIntStaticValue);		
	}
	
	public void testMinIntStaticValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField intField = getJavaField(thisJavaObject, "minIntStaticValue");
		
		Integer intObj = (Integer) intField.get(null);
		
		assertEquals(intObj.intValue(), SetupJavaField_get.minIntStaticValue);		
	}
	
	public void testFloatStaticValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField floatField = getJavaField(thisJavaObject, "floatStaticValue");
		
		Float floatObj = (Float) floatField.get(null);
		
		assertEquals(floatObj.floatValue(), SetupJavaField_get.floatStaticValue, 0.0);		
	}
	
	public void testMaxFloatStaticValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField floatField = getJavaField(thisJavaObject, "maxFloatStaticValue");
		
		Float floatObj = (Float) floatField.get(null);
		
		assertEquals(floatObj.floatValue(), SetupJavaField_get.maxFloatStaticValue, 0.0);		
	}
	
	public void testMinFloatStaticValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField floatField = getJavaField(thisJavaObject, "minFloatStaticValue");
		
		Float floatObj = (Float) floatField.get(null);
		
		assertEquals(floatObj.floatValue(), SetupJavaField_get.minFloatStaticValue, 0.0);		
	}
	
	public void testDoubleStaticValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField doubleField = getJavaField(thisJavaObject, "doubleStaticValue");
		
		Double doubleObj = (Double) doubleField.get(null);
		
		assertEquals(doubleObj.doubleValue(), SetupJavaField_get.doubleStaticValue, 0.0);		
	}
	
	public void testMaxDoubleStaticValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField doubleField = getJavaField(thisJavaObject, "maxDoubleStaticValue");
		
		Double doubleObj = (Double) doubleField.get(null);
		
		assertEquals(doubleObj.doubleValue(), SetupJavaField_get.maxDoubleStaticValue, 0.0);		
	}
	public void testMinDoubleStaticValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField doubleField = getJavaField(thisJavaObject, "minDoubleStaticValue");
		
		Double doubleObj = (Double) doubleField.get(null);
		
		assertEquals(doubleObj.doubleValue(), SetupJavaField_get.minDoubleStaticValue, 0.0);		
	}
	public void testStringStaticValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField stringField = getJavaField(thisJavaObject, "stringStaticValue");
		
		JavaObject stringObject = (JavaObject) stringField.get(null);
		
		assertEquals(String.class.getName().replace('.','/'), stringObject.getJavaClass().getName());		
	}
	
	public void testObjectStaticValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField objectField = getJavaField(thisJavaObject, "objectStaticValue");
		
		JavaObject objectObject = (JavaObject) objectField.get(null);
		
		assertEquals(Object.class.getName().replace('.','/'), objectObject.getJavaClass().getName());		
	}
	
	public void testNullStaticValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField objectField = getJavaField(thisJavaObject, "nullStaticValue");
		
		JavaObject objectObject = (JavaObject) objectField.get(null);
		
		assertNull(objectObject);		
	}

	public void testWrongByteValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField objectField = getJavaField(thisJavaObject, "byteValue");
		
		try{
			Byte byteObj = (Byte) objectField.get(wrongClassObject);
			fail("JavaField.get() should have thrown IllegalArgumentException as passed wrong object.");
		}catch (IllegalArgumentException e) {
			// expected
		}
		
	}
	
	public void testWrongObjectValue() throws Exception {
		JavaObject thisJavaObject = getScenerioReference();
		JavaField objectField = getJavaField(thisJavaObject, "objectValue");
		
		try{
			JavaObject objectObj = (JavaObject) objectField.get(wrongClassObject);
			fail("JavaField.get() should have thrown IllegalArgumentException as passed wrong object.");
		}catch (IllegalArgumentException e) {
			// expected
		}
		
	}
}
