/*******************************************************************************
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ******************************************************************************/
package org.apache.kato.tck.scenario142.javaruntime;

import java.util.Iterator;

import javax.tools.diagnostics.image.CorruptDataException;
import javax.tools.diagnostics.image.DataUnavailable;
import javax.tools.diagnostics.runtime.java.JavaRuntime;
import javax.tools.diagnostics.runtime.java.JavaVMInitArgs;
import javax.tools.diagnostics.runtime.java.JavaVMOption;

import org.apache.kato.tck.harness.TCKJavaRuntimeTestcase;
import org.apache.kato.tck.scenario142.javaruntime.SetupJavaRuntime;


/**
 * 
 * 
 */
public class TestJavaRuntime extends TCKJavaRuntimeTestcase {

	
	public void testJavaJavaRuntime_getVersion() throws CorruptDataException, DataUnavailable
	{
		
		JavaRuntime runtime=getJavaRuntime();
		String version=runtime.getVersion();
		System.out.println("runtime.getVersion "+version);
		assertNotNull(version);
	}

	public void testJavaJavaRuntime_getVersionDetail() throws CorruptDataException, DataUnavailable
	{
		
		JavaRuntime runtime=getJavaRuntime();
		String version=runtime.getVersion();
		
		
		JavaVMInitArgs args=runtime.getJavaVMInitArgs();
		Iterator i=args.getOptions().iterator();
		while(i.hasNext()) {
			JavaVMOption option=(JavaVMOption) i.next();
			String data=option.getOptionString();
			if(data.startsWith(SetupJavaRuntime.DTCK_TEST_RUNTIME_VERSION)) {
				String received=data.substring(SetupJavaRuntime.DTCK_TEST_RUNTIME_VERSION.length());
				assertTrue(version.indexOf(received) != -1);
				return; // test passed
			}
			
		}
		
		fail("expected to see vm option for system property starting "+SetupJavaRuntime.DTCK_TEST_RUNTIME_VERSION);
	}
	
	public void testJavaRuntime_getFullVersion()
	{
		JavaRuntime runtime=(JavaRuntime) getJavaRuntime();
		String theFV=null;
		try {
			theFV=runtime.getFullVersion();
		} catch (CorruptDataException e) {
			fail();
		}
		assertNotNull(theFV);
		assertTrue(theFV.length() > 0);
	}


}

