/*******************************************************************************
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ******************************************************************************/
package org.apache.kato.tck.scenario142.javaruntime;

import java.util.Iterator;

import javax.tools.diagnostics.image.CorruptDataException;
import javax.tools.diagnostics.runtime.java.JavaMethod;
import javax.tools.diagnostics.runtime.java.JavaRuntime;

import org.apache.kato.tck.harness.TCKJavaRuntimeTestcase;


public class TestJavaRuntime_getCompiledMethods extends TCKJavaRuntimeTestcase {
	public void testHasCompiledMethods() {
		JavaRuntime runtime=getJavaRuntime();
		Iterator compiledMethods=runtime.getCompiledMethods().iterator();
		assertNotNull(compiledMethods);
		assertTrue(compiledMethods.hasNext());
	}
	
	public void testConfiguredCompiledMethods() {
		JavaRuntime runtime=getJavaRuntime();
		Iterator compiledMethods=runtime.getCompiledMethods().iterator();
		boolean found = false;
		while (compiledMethods.hasNext() && !found) {
			Object next = compiledMethods.next();
			if (!(next instanceof JavaMethod)) {
				continue;
			}
			JavaMethod method = (JavaMethod)next;
			try {
				String methodName = method.getName();
				// System.out.println("Current method is: "+ methodName);
				if ("jitMe".equals(methodName)) {
					return;
				}
			} catch (CorruptDataException cde) {
				assertNotNull(cde.getCorruptData());
				continue;
			}
		}
		fail("Compiled method not found");
	}
}
