/*******************************************************************************
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ******************************************************************************/

package org.apache.kato.tck.tests.legacy;

import java.util.List;

import javax.tools.diagnostics.image.CorruptDataException;
import javax.tools.diagnostics.image.ImageSection;
import javax.tools.diagnostics.runtime.java.JavaHeap;
import javax.tools.diagnostics.runtime.java.JavaObject;
import javax.tools.diagnostics.runtime.java.JavaRuntime;

import org.apache.kato.tck.harness.TCKJavaRuntimeTestcase;

/**
 * 
 */
public class TestJavaHeaps  extends TCKJavaRuntimeTestcase {

	
	public void testJavaHeaps() {
		JavaRuntime runtime=getJavaRuntime();
		
		List<JavaHeap> heaps=runtime.getHeaps();
		
		if(heaps.isEmpty()) return; // no heaps to test
		
		int counter=0;
		
		for(JavaHeap heap:heaps) {
		
			
			String name=heap.getName();
			assertNotNull("Entry "+counter+":name is null",name);
			
			List<JavaObject> objects=heap.getObjects();
			assertNotNull("Entry "+counter+":objects list is null",objects);
			
			List<ImageSection> sections=heap.getSections();
			assertNotNull("Entry "+counter+":image sections list is null",sections);
					
			
			counter++;
		}
		
		
		
	}
}
