/*******************************************************************************
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ******************************************************************************/
package org.apache.kato.tests.junit;

import junit.framework.Test;
import junit.framework.TestSuite;

public class AllTests {

	public static Test suite() {
		TestSuite suite = new TestSuite("Test for org.apache.kato.tests.junit");
		//$JUnit-BEGIN$
		suite.addTestSuite(JavaRuntimeTest.class);
		suite.addTestSuite(ImageProcessTest.class);
		suite.addTestSuite(ImageTest.class);
		suite.addTestSuite(ImageAddressSpaceTest.class);
		suite.addTestSuite(ImageModuleTest.class);
		suite.addTestSuite(JavaThreadTest.class);
		suite.addTestSuite(ImageThreadTest.class);
		suite.addTestSuite(JavaStackFrameTest.class);
		suite.addTestSuite(JavaMonitorTest.class);
		suite.addTestSuite(JavaMethodTest.class);
		suite.addTestSuite(ImageSectionTest.class);
		suite.addTestSuite(JavaHeapTest.class);
		suite.addTestSuite(JavaClassLoaderTest.class);
		suite.addTestSuite(JavaClassTest.class);
		suite.addTestSuite(JavaObjectTest.class);
		suite.addTestSuite(ImagePointerTest.class);
		suite.addTestSuite(ImageRegisterTest.class);
		suite.addTestSuite(ImageStackFrameTest.class);
		suite.addTestSuite(ImageSymbolTest.class);
		suite.addTestSuite(JavaFieldTest.class);
		suite.addTestSuite(JavaLocationTest.class);
		suite.addTestSuite(ImageFactoryTest.class);
		//$JUnit-END$
		return suite;
	}

}
