/*******************************************************************************
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ******************************************************************************/
package org.apache.kato.tests.scenarios;

public class ArrayletTestInstance
{
	private int[] DTFJ_ARRAYLET_INTS;
	private byte[] DTFJ_ARRAYLET_BYTES;
	private StringContainer[] DTFJ_ARRAYLET_STRINGCONTAINER;
	
	public ArrayletTestInstance(int length)
	{
		DTFJ_ARRAYLET_INTS = new int[length];
		DTFJ_ARRAYLET_BYTES = new byte[length];
		DTFJ_ARRAYLET_STRINGCONTAINER = new StringContainer[length];
		
		for (int i = 0; i < length; i++)
		{
			int value = length - i;
			DTFJ_ARRAYLET_INTS[i] = value;
			DTFJ_ARRAYLET_BYTES[i] = (byte)value;
			DTFJ_ARRAYLET_STRINGCONTAINER[i] = new StringContainer(value);
		}
	}
	
	private class StringContainer
	{
		private String _stringField;
		
		public StringContainer(int value)
		{
			_stringField = Integer.toString(value);
		}
		
		public String toString()
		{
			return _stringField;
		}
	}
}
