/*******************************************************************************
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ******************************************************************************/
package org.apache.kato.katoview.commands;

import java.util.Vector;

import org.apache.kato.katoview.Output;
import org.apache.kato.katoview.commands.setcommands.SetHeapdumpCommand;
import org.apache.kato.katoview.commands.setcommands.SetLoggingCommand;


public class SetCommand extends Command {

	public SetCommand(Output o){
		super(o, "set", "", "");
		
		child_commands = new Vector();
		child_commands.add(new SetLoggingCommand(o));
		child_commands.add(new SetHeapdumpCommand(o));
	}

}
