/*******************************************************************************
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ******************************************************************************/
package org.apache.kato.katoview.commands.helpers;

import javax.tools.diagnostics.runtime.java.JavaMonitor;

public class MonitorState {
	
	public static int WAITING_TO_ENTER = 1;
	public static int WAITING_TO_BE_NOTIFIED_ON = 2;

	private JavaMonitor jm;
	private int status;
	
	public MonitorState(JavaMonitor _jm, int _status)
	{
		jm = _jm;
		status = _status;
	}
	
	public JavaMonitor getMonitor()
	{
		return jm;
	}
	
	public int getStatus()
	{
		return status;
	}
	
	public String getStatusString()
	{
		if (status == WAITING_TO_ENTER) {
			return "waiting to enter";
		} else if (status == WAITING_TO_BE_NOTIFIED_ON) {
			return "waiting to be notified on";
		} else {
			return "<unknown status>";
		}
	}
	
	public static String getStatusString(int statusToGet)
	{
		if (statusToGet == WAITING_TO_ENTER) {
			return "waiting to enter";
		} else if (statusToGet == WAITING_TO_BE_NOTIFIED_ON) {
			return "waiting to be notified on";
		} else {
			return "<unknown status>";
		}
	}
}
